#
# APIのサンプル
#
# 下記バージョンで動作確認しています。
# ＜動作確認バージョン＞
# perl v5.10
#
# 下記モジュールが必要です。
# ＜必要なモジュール＞
# perl-Crypt-SSLeay
# (example: yum install perl-Crypt-SSLeay)
# perl-JSON
# (example: yum install perl-JSON)
#
use HTTP::Request::Common;
use LWP::UserAgent;
use JSON;
use Cwd 'getcwd';

# 可変
# 接続先URLに利用する設定
# https://●●●●●/■■■■■/api/v1/▲▲▲▲▲/get
my $domain = "●●●●●";           # URLのドメイン部分を指定（xxx.hm-f.jpなど）
my $accountUrl = "■■■■■";       # アカウント文字列
my $apiType = "▲▲▲▲▲";          # APIの種類
my $requestJson = <<POST_JSON;  # API用のパラメータを指定(JSON形式)
{
  "search" : {
    "type" : "cancel"
  }
}
POST_JSON

# 各種設定 > 各種設定メニュー > 基本設定 > APIトークン で発行<<APIトークン>>
$apiToken = "<<APIトークン>>";

my $url = "https://${domain}/${accountUrl}/api/v1/${apiType}/get";
my $userAgent = LWP::UserAgent->new();
my $header = HTTP::Headers->new;
$header->push_header('Content-Type' => 'application/json');
$header->push_header('X-HM-apitoken' => $apiToken);
$header->push_header('X-Content-Type-Options' => 'nosniff');
$header->push_header('Connection' => 'Close');

my $reqest = HTTP::Request->new('POST', $url, $header, $requestJson);
my $response = $userAgent->request($reqest);

if (!$response->is_success || $response->status_line ne '200 OK' || $response->content_type ne 'text/csv') {
  if ($response->content_type eq 'application/json') {
    my $data = decode_json($response->content);
    printf "処理に失敗しました。[line=%s]\n", __LINE__;
    printf "  status : %s\n  code : %s\n  url : %s\n  query : %s\n  errors : %s\n  version : %s\n  accessTime : %s\n"
      , $data->{'status'}
      , $data->{'code'}
      , $data->{'url'}
      , encode_json($data->{'query'})
      , encode_json($data->{'errors'})
      , $data->{'version'}
      , $data->{'accessTime'}
  } else {
    print $response->content;
  }
  die;
}

my @filename = split("''", $response->header('Content-Disposition'));
my $downloadFilePath = getcwd . "/" . $filename[-1];

my $file = $response->decoded_content(charset => 'UTF-8');
if (!open (SAVE, ">:encoding(UTF-8)", $downloadFilePath)) {
  print "ファイルオープンに失敗しました。[file=" . $downloadFilePath . "][line=" . __LINE__ ."]\n";
  die
}
print SAVE $file;
close SAVE;

print "処理に成功しました。\n";
print "[csv file: ${downloadFilePath}]\n"; 
exit;
